function [x,P,SNR,MSSIM,MAE] = searchHP(p0,x0,I,algorithm,crit,iscvx,idx,iter)

% p0 - init parameter vector
% x0 - init image (??????)
% I - original image
% algorithm
% crit - which criterium SNR, etc
% iscvx - is convex?
% idx - index of parameters to be estimated
% iter - max number of iterations --- let say 100
%searchHP(p0,x0,I,y,H,H_adj,fidelity,penalty,eta,xmin,xmax,iso,tau,iter)
% primaldualrecPG_Hyb(x00,y,h,NbIt,nx,ny,v,m,alpha,p(1)^2,p(2)^2, xmin,xmax,I,data_fidelity,prior, VHes, VTV, gamma);

clc
close all

disp('SIMPLEX ALGORITHM');


[Nx,Ny] = size(I);
taille = length(idx);

p = p0;
psimp = p0(idx);

disp(['Estimation of parameters : ',num2str(idx)]);
[psimp,t]=Simplex('init',psimp);
p(idx) = psimp;
 
P = zeros(iter,taille);
 
SNR = zeros(iter,1);
MSSIM = SNR;
MAE = SNR;

for k=1:iter
    disp(['ITERATION ',num2str(k)])
    
    x = algorithm(x0,p);
    
    %size(x)
    snr = 10*log10(sum(I(:).^2)/sum((I(:)-x).^2));
    mae = sum(abs((I(:)-x)))/(Nx*Ny);
    im1 = reshape(x,Nx,Ny);
    im2 = reshape(I,Nx,Ny);
    [mssim, dic] = ssim(im1,im2);
    mapc = max(size(find((abs(I(:)-x))>0.5))) /(Nx*Ny);

    
    %%%%%
    % SO I NEED JUST TO ADD HERE TWO SPECIAL CASES
    %%%%%
    switch crit
        case 1
            f = -snr;
        case 2
            f = mae;
        case 3
            f = - mssim;
        case 4
            f = mapc;
        case 5
            f = 0;
    end

    [psimp,t]=Simplex(f);
    
%     if(sum(psimp<=0)>0)
%         disp('ENTREE NEGATIVE!!')
%         [psimp,t]=Simplex('init',abs(psimp));
%     end
    
    if(iscvx)   %convex case => unique minimizer
    x0 = x;
    end
    

    % I NEED TO HAVE ADDITIONAL VECTORS HERE FOR NEW CRITERIA
    SNR(k) = snr;
    MSSIM(k) = mssim;
    MAE(k) = mae;
    MAPC(k) = mapc;
    
    figure(1)
    imagesc(reshape(x,size(I,1),size(I,2)));
    colormap gray;
    set(gca,'xtick',[ ])
    set(gca,'ytick',[ ])
    title(['k = ',num2str(k),' : SNR = ',num2str(snr),' ; MSSIM = ',num2str(mssim),' ; MAE = ',num2str(mae)])
    xlabel(num2str((p(:).^2)'));
    pause(0.1);
    
    disp(['RESULTS: ',num2str(k),'th iterate :']);
    for j=1:taille
        disp(['p(',num2str(idx(j)),')^2 = ',num2str(psimp(j)^2)]);
    end
    disp(['SNR = ',num2str(snr),' ; MSSIM = ',num2str(mssim),' ; MAE = ',num2str(mae),' MAPC = ',num2str(mapc)]);
    disp('**********');
    
    %update
    P(k,:) = psimp';
    p(idx) = psimp;
end

psimp=Simplex('centroid'); % obtain the final value.
p(idx) = psimp;
 
disp('Final result')
x = algorithm(x0,p);
snr = 10*log10(sum(I(:).^2)/sum((I(:)-x).^2));
mae = sum(abs((I(:)-x)))/(Nx*Ny);
[mssim, dic] = ssim(im1,im2);
mapc = max(size(find((abs(I(:)-x))>0.5))) /(Nx*Ny);
for j=1:taille
        disp([' OPTIMAL p(',num2str(idx(j)),')^2 = ',num2str(psimp(j)^2)]);
end
disp(['SNR FINAL = ',num2str(snr),' ; MSSIM FINAL= ',num2str(mssim),' ; MAE FINAL= ',num2str(mae),' MAPC FINAL= ',num2str(mapc)]);
