function gTx = grad_gaussiangast(Tx,y,taby,tabn, gvar,gmean, alpha,tolerance)   %Tx,y,taby,tabn,gvar,gmean, alpha
Tneg = (Tx < 0 ) ; 
Tpos = (Tx >= 0 ) ;

% Build quadratic approximation in Tx < 0
cteGAST = 3/8  + gvar;
A = cteGAST^(-3/2) * y./2 ;
B = (2-y./sqrt(cteGAST));
gTx(Tneg) =  A(Tneg) .* Tx(Tneg) + B(Tneg) ;

% Build exact gradient if Tx >= 0
gTx(Tpos) =  2-y(Tpos)./sqrt(Tx(Tpos) + cteGAST) ;
