function gamma = getGamma(data_fidelity, L, h, y, v, m,nx,ny)


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Stepsize
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%normh = normest(h, 1e-3); -> WRONG
normh = max(max(abs(fft2(h)).^2)); %because of convolution operator !

switch data_fidelity
    case 'PoissGauss'
        mu = normh^2 * ( 1 - exp(-1/v) ) * exp ( (2* (max(y) - m) -1 )/v);
        tau = mu + normest(L, 1e-3);  
        
    case 'Gauss'
        mu = normh^2/(2*v) ;
        tau = mu + normest(L, 1e-3);  
        
    case 'Poiss'
        tau =  sqrt(normh^2 + (normest(L, 1e-3))^2);
        
    case 'SPoiss'    
        
        tau =  sqrt(normh^2 + (normest(L, 1e-3)))^2; % we assume here that we compute prox
        
    case 'GAST'
        cteGAST = 3/8  + v; %Generalized Anscombe transform on y !
        %yGAST = 2*sqrt(max(y + cteGAST,0)) ;
        Mu = (cteGAST^(-3/2)) * y./2  ; %Lipschitz constant of GAST criterion
        if(h==1)
            mu = max(Mu);
        else
            mu = CalculDeNorme(Mu,h,nx, ny );
        end
        tau = mu + normest(L, 1e-3);  
        
    case 'EXP'
        coef = (2*(y)-ones(size(y)))/(2*v);
        coef1 = (2*(y)+2*v-ones(size(y)))/(2*v^2);
        Mu = coef1.*exp(coef);
        mu = normh^2 * max(Mu(:));
        tau = mu + normest(L, 1e-3);  
        
    case 'WL2'
        a = 1; 
        b = v;
        mu = normh^2 * max((a.*y + b).^2./b^3);
        tau = mu + normest(L, 1e-3); 
end


epsilon = min(1e-8,1/(tau+1)); 
gamma =  (1-epsilon)/tau; 
